4 # Required-Start: $remote_fs $network $syslog
5 # Required-Stop: $remote_fs $network $syslog
6 # Default-Start: 2 3 4 5
8 # Short-Description: initscript for iodined
9 # Description: initscript for iodined
12 # Author: gregor herrmann <gregor+debian@comodo.priv.at>
16 # PATH should only include /usr/* if it runs after the mountnfs.sh script
17 PATH=/sbin:/usr/sbin:/bin:/usr/bin
18 DESC="IP over DNS tunneling server"
20 DAEMON=/usr/sbin/$NAME
23 PIDFILE=/var/run/$NAME.pid
24 SCRIPTNAME=/etc/init.d/$NAME
25 CHROOTDIR=/var/run/iodine
27 # Exit if the package is not installed
28 [ -x "$DAEMON" ] || exit 0
30 # Load the VERBOSE setting and other rcS variables
33 # Define LSB log_* functions.
34 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
35 . /lib/lsb/init-functions
39 [ -r /etc/default/$DEFAULT ] && . /etc/default/$DEFAULT
40 if [ "$START_IODINED" != "true" ] ; then
41 [ "$VERBOSE" != no ] && log_progress_msg "- automatic start disabled" && log_end_msg 0
44 if [ -n "$IODINED_ARGS" ] && [ -n "$IODINED_PASSWORD" ] ; then
45 DAEMON_ARGS="-u iodine -t $CHROOTDIR $IODINED_ARGS"
47 [ "$VERBOSE" != no ] && log_warning_msg "$NAME is not fully configured. Change this in /etc/default/$DEFAULT or run dpkg-reconfigure $DEFAULT."
55 if [ -d "$CHROOTDIR" ] || mkdir -p "$CHROOTDIR" ; then
58 [ "$VERBOSE" != no ] && log_failure_msg "$CHROOTDIR does not exist and can't be created."
64 # Function that starts the daemon/service
68 # populate $DAEMON_ARGS
74 # 0 if daemon has been started
75 # 1 if daemon was already running
76 # 2 if daemon could not be started
77 start-stop-daemon --start --quiet --exec $DAEMON --test > /dev/null \
79 start-stop-daemon --start --quiet --exec $DAEMON -- $DAEMON_ARGS -P "$IODINED_PASSWORD" \
81 # Add code here, if necessary, that waits for the process to be ready
82 # to handle requests from services started subsequently which depend
83 # on this one. As a last resort, sleep for some time.
87 # Function that stops the daemon/service
92 # 0 if daemon has been stopped
93 # 1 if daemon was already stopped
94 # 2 if daemon could not be stopped
95 # other if a failure occurred
96 start-stop-daemon --stop --quiet --retry=TERM/5/KILL/5 --exec $DAEMON
98 [ "$RETVAL" = 2 ] && return 2
99 # Wait for children to finish too if this is a daemon that forks
100 # and if the daemon is only ever run from this initscript.
101 # If the above conditions are not satisfied then add some other code
102 # that waits for the process to drop all resources that could be
103 # needed by services started subsequently. A last resort is to
104 # sleep for some time.
105 start-stop-daemon --stop --quiet --oknodo --retry=0/5/KILL/5 --exec $DAEMON
106 [ "$?" = 2 ] && return 2
107 # Many daemons don't delete their pidfiles when they exit.
114 [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
117 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
118 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
122 [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
125 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
126 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
130 status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
132 restart|force-reload)
133 log_daemon_msg "Restarting $DESC" "$NAME"
140 1) log_end_msg 1 ;; # Old process is still running
141 *) log_end_msg 1 ;; # Failed to start
151 echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2